package com.example.call_with_skype

import android.content.Context
import android.content.Intent
import android.content.pm.PackageManager
import android.net.Uri
import android.util.Log
import androidx.core.content.ContextCompat.startActivity
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

class CallWithSkypePlugin(val registrar: Registrar) : MethodCallHandler {
  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "call_with_skype")
      channel.setMethodCallHandler(CallWithSkypePlugin(registrar))
    }
  }

  override fun onMethodCall(call: MethodCall, result: Result) {
    when (call.method) {
        "callWithSkype" -> {
          result.success(skypeCall(call.argument<String>("skype_id")!!))
        }
        "openPlayStore" -> {
          result.success(openPlayStore(registrar.activeContext(),packName))
        }
        else -> {
          result.notImplemented()
        }
    }
  }


  //Skype
  var packName = "com.skype.raider"
  private fun skypeCall(skypeId:String):String {
    try {
      return if(isAppInstalled(registrar.activeContext(),packName)) {
        if(isAppEnabled(registrar.activeContext(),packName)){
          val sky = Intent("android.intent.action.VIEW")
          sky.data = Uri.parse("skype:$skypeId?call&video=true")
          registrar.activeContext().startActivity(sky)
          "SUCCESS"
        }else{
          "DISABLED"
        }
      }else{
        "NOT_INSTALLED"
      }
    }catch (e:Exception){
      return "ERROR"
    }
  }
  private fun isAppInstalled(context: Context, packageName: String): Boolean {
    val pm: PackageManager = context.packageManager
    try {
      pm.getPackageInfo(packageName, PackageManager.GET_ACTIVITIES)
      return true
    }
    catch (ignored: PackageManager.NameNotFoundException) {
    }

    return false
  }
  private fun isAppEnabled(context: Context, packageName: String): Boolean {
    var appStatus = false
    try {
      val ai = context.packageManager.getApplicationInfo(packageName, 0)
      appStatus = ai.enabled
    } catch (e: PackageManager.NameNotFoundException) {
      e.printStackTrace()
    }
    return appStatus
  }
  private fun openPlayStore(myContext: Context, packageName: String):String{
    return try {
      val marketUri = Uri.parse("market://details?id=$packageName")
      val myIntent = Intent(Intent.ACTION_VIEW, marketUri)
      myIntent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
      myContext.startActivity(myIntent)
      "SUCCESS"
    }catch (_:Exception){
      "ERROR"
    }
  }
}
